import type { IterableContainer } from './_types';
type Evolver<T> = T extends object ? T extends IterableContainer ? never : {
    readonly [K in keyof T]?: ((data: Required<T>[K]) => unknown) | Evolver<T[K]>;
} : never;
type Evolved<T, E> = T extends object ? {
    -readonly [K in keyof T]: K extends keyof E ? E[K] extends (...arg: any) => infer R ? R : Evolved<T[K], E[K]> : Required<T>[K];
} : T;
export declare function evolve<T extends object, E extends Evolver<T>>(object: T, evolver: E): Evolved<T, E>;
export declare function evolve<T extends object, E extends Evolver<T>>(evolver: E): (object: T) => Evolved<T, E>;
export {};
//# sourceMappingURL=evolve.d.ts.map